// C Source File
// Created 2001-06-10; 11:29:35
// A JEsystem production
// Copyright 2001
//
// JesJumper
// Version 1.0!



#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
 void delayt(long int del) // My delay routine
{
int i;
long int per;
for(i = 1; i > 0; i--)
{
for(per = del; per > 0; per--);
}
}
#include "extgraph.h"
#include "defsvars.h"
#include "sound.h"
#include "map_engine.h"
#include "physics.h"
#include "hud.h"
#include "logo.h"
#include "intro.h"
#include "ai.h"
#include "menu.h"
#include "death.h"
#include "iwon.h"
#include "thegame.h"
#include "maps.h"
#include "levload.h"
#include "levloadset.h"
#include "loadmenu.h"
#include "cfg.h"

short _ti89;              // Produce .9XZ File

// Main Function
void _main(void)
{
  INT_HANDLER save_int_1 = GetIntVec(AUTO_INT_1),save_int_4 = GetIntVec(AUTO_INT_4),save_int_5 = GetIntVec(AUTO_INT_5);

int quit_type,merr;
char typechoice;
int setnum=2;
lives=2;
//Directs ints to nothing
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
  SetIntVec(AUTO_INT_4, DUMMY_HANDLER);
  SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
//Allocates space for these vars...
  virtual_light = malloc (LCD_SIZE);
virtual_dark  = malloc (LCD_SIZE);
	map_array = calloc (37, sizeof (*map_array));
reload  = malloc ((sizeof(char)*9));
cbuffer  = malloc ((sizeof(char)*9));
filetitle=calloc (30,sizeof(char));
fileauthor=calloc (30,sizeof(char));
sound  = malloc (sizeof(int));
deathanim  = malloc (sizeof(int));
introanim  = malloc (sizeof(int));
*sound=FALSE;
*deathanim=TRUE;
*introanim=TRUE;
  if (!GrayOn ()) return;
  			  FolderCur($(jes),FALSE);

	loadcfg();
	HW2 = IsRealHW2() ;
if(!(*introanim)) 
{
		ClearGrayScreen2B(virtual_light,virtual_dark);
	FloodFillMF (0,0,0x6BD6,virtual_light);
	FloodFillMF (0,0,0x6E73,virtual_dark);
	FastCopyScreen(virtual_light,GetPlane(LIGHT_PLANE));
	FastCopyScreen(virtual_dark,GetPlane(DARK_PLANE));
	DrawGrayRect(0,0,160,55,COLOR_WHITE,RECT_FILLED);	
	jeslogo(0,0,64,49);
DrawGrayStrExt(0,90," JesJump v1.0 ",A_REPLACE | A_CENTERED,F_8x10);	goto backagain;
}
	intro_map();
	titlescreen();
	
	
backagain:
	quit_type=menu();
	//Quits
	if (quit_type==1) goto ohwell;
//in loadmenu.h
pickspeed();
	typechoice = picktype();
	
	ClearGrayScreen();
	
	
	
baderr:
	if (typechoice==0) {lives=2;
// Map 1, the start up procedure
	map1();
	levsplash("JesJump Level One","Jon Eriksson,Malcolm Smith");
	if (quit_type==2)	quit_type=Game();
	while (quit_type==5) {
		map1();
		quit_type=Game();
	}
// MAP 2
	if (quit_type==2) {
		map2();
		levsplash("JesJump Level Two","Jon Eriksson,Malcolm Smith");
		quit_type=Game();
	}	
	while (quit_type==5) {
		map2();
		quit_type=Game();
	}
// MAP 3
	if (quit_type==2) {
		map3();
		levsplash("JesJump Level Three","Jon Eriksson,Malcolm Smith");
		quit_type=Game();
	}	
	while (quit_type==5) {
		map3();
		quit_type=Game();
	}
// MAP 4
	if (quit_type==2) {
		map4();
		levsplash("JesJump Level Four","Jon Eriksson,Malcolm Smith");
		quit_type=Game();
	}	
	while (quit_type==5) {
		map4();
		quit_type=Game();
	}
// MAP 5	
	if (quit_type==2) {
		map5();
		levsplash("JesJump Level Five","Jon Eriksson,Malcolm Smith");
		quit_type=Game();
	}	
	while (quit_type==5) {
		map5();
		quit_type=Game();
	}
// MAP 6	
	if (quit_type==2) {
		map6();
		levsplash("JesJump Level Six","Jon Eriksson,Malcolm Smith");
		quit_type=Game();
	}	
	while (quit_type==5) {
		map6();
		quit_type=Game();
	}
// MAP 7	
	if (quit_type==2) {
		map7();
		levsplash("JesJump: Last Level!","Jon Eriksson,Malcolm Smith");
		quit_type=Game();
	}	
	while (quit_type==5) {
		map7();
		quit_type=Game();
	}
	if (quit_type==2) {
	youwon();congrats();
	delayt(300000);}
	if (quit_type==9) {
	ClearGrayScreen2B(virtual_light,virtual_dark);
	FloodFillMF (0,0,0x6BD6,virtual_light);
	FloodFillMF (0,0,0x6E73,virtual_dark);
	FastCopyScreen(virtual_light,GetPlane(LIGHT_PLANE));
	FastCopyScreen(virtual_dark,GetPlane(DARK_PLANE));
	DrawGrayRect(0,0,159,55,COLOR_WHITE,RECT_FILLED);	
	jeslogo(0,0,64,49);goto backagain;}	
//ending the typechoice 0 below
}

if (typechoice==2) {lives=2;
	merr = loadlev(map_array,0,filetitle,fileauthor);
	if (merr==0) {
		ClearGrayScreen();
		FontSetSys(F_6x8);
		DrawGrayStr(1,1,"Something went wrong!",A_NORMAL);
		DrawGrayStr(1,12,"JesJump will now load",A_NORMAL);
		DrawGrayStr(1,23,"internal levels...",A_NORMAL);
		delayt(300000);typechoice=0;goto baderr;}
	if (quit_type==2)	quit_type=Game();
		if (quit_type==1)	goto ohwell;
		if ((quit_type==2) || (quit_type==9)) {

	ClearGrayScreen2B(virtual_light,virtual_dark);
	FloodFillMF (0,0,0x6BD6,virtual_light);
	FloodFillMF (0,0,0x6E73,virtual_dark);
	FastCopyScreen(virtual_light,GetPlane(LIGHT_PLANE));
	FastCopyScreen(virtual_dark,GetPlane(DARK_PLANE));
	DrawGrayRect(0,0,160,55,COLOR_WHITE,RECT_FILLED);	
	jeslogo(0,0,64,49);goto backagain;}
		while (quit_type==5) {
			loadlev(map_array,1,filetitle,fileauthor);
		quit_type=Game();	}
	
	}
	
	
	
	if (typechoice==1) {lives=2;setnum=2;
	merr = loadlevset(map_array,0,filetitle,fileauthor,1);
	if (merr==0) goto toberror;
if (quit_type==2)	quit_type=Game();
	while (quit_type==5) {
loadlevset(map_array,1,filetitle,fileauthor,1);
		quit_type=Game();
	}
	while(setnum!=8){
	if (quit_type==2) {
	merr = loadlevset(map_array,2,filetitle,fileauthor,setnum++);
	if (merr==0) goto tobaderr;
		quit_type=Game();
			if (quit_type==1 || quit_type==9)	break;
	}	
	while (quit_type==5) {
loadlevset(map_array,1,filetitle,fileauthor,setnum-1);
		quit_type=Game();
	}
			if (quit_type==1 || quit_type==9)	break;
	}
		if ((quit_type==2) || (quit_type==9)) {
	if (quit_type==2) {
	youwon();congrats();
	delayt(300000);}
	ClearGrayScreen2B(virtual_light,virtual_dark);
	FloodFillMF (0,0,0x6BD6,virtual_light);
	FloodFillMF (0,0,0x6E73,virtual_dark);
	FastCopyScreen(virtual_light,GetPlane(LIGHT_PLANE));
	FastCopyScreen(virtual_dark,GetPlane(DARK_PLANE));
	DrawGrayRect(0,0,160,55,COLOR_WHITE,RECT_FILLED);	
	jeslogo(0,0,64,49);goto backagain;}					
	}	
	
	
	
ohwell:	

savecfg();

  GrayOff ();
  SetIntVec(AUTO_INT_1, save_int_1);
	SetIntVec(AUTO_INT_4, save_int_4);
	SetIntVec(AUTO_INT_5, save_int_5);
delayt(30000);  
OSLinkReset();
	FolderCur($(main),FALSE);
	free(virtual_light);
	free(virtual_dark);

	free(map_array);
	free(reload);
	free(filetitle);
	free(fileauthor);
	free(cbuffer);
	free(sound);
free(deathanim);
	GKeyFlush();
return;
tobaderr:
	youwon();
	delayt(2000000);
	ClearGrayScreen2B(virtual_light,virtual_dark);
	FloodFillMF (0,0,0x6BD6,virtual_light);
	FloodFillMF (0,0,0x6E73,virtual_dark);
	FastCopyScreen(virtual_light,GetPlane(LIGHT_PLANE));
	FastCopyScreen(virtual_dark,GetPlane(DARK_PLANE));
	DrawGrayRect(0,0,160,55,COLOR_WHITE,RECT_FILLED);	
	jeslogo(0,0,64,49);goto backagain;
toberror:
	ClearGrayScreen();
	DrawGrayStr(1,1,"Something went wrong!",A_NORMAL);
	DrawGrayStr(1,12,"JesJump will now load",A_NORMAL);
	DrawGrayStr(1,23,"internal levels...",A_NORMAL);
	delayt(300000);typechoice=0;goto baderr;

}
