// C Header File
// Created 2001-06-22; 14:29:31
// This header file contains all functions that handels the
// physic of the player
#define ARROWS_ROW 0xfffe      // Constants for low-level keyboard access
#define LEFT_KEY 2
#define RIGHT_KEY 8
int update_player_x(void)
{
	int scan=0;
	if (player_x_speed>0) {
		while (scan<16) {
			SetPlane(DARK_PLANE);
			if (GetPix(player_x+8,player_y+scan)) {
				player_x_speed=0;
				return 0;
			}
			SetPlane(LIGHT_PLANE);
			if (GetPix(player_x+8,player_y+scan)) {
				player_x_speed=0;
				return 0;
			}
			scan++;
		}
		player_x++;
		if ((!(_rowread(ARROWS_ROW) & RIGHT_KEY)))	player_x_speed--;
		if (player_x_speed==1) return 8;
		if (player_x_speed==2) return 5;
		if (player_x_speed==3) return 3;
		if (player_x_speed==4) return 2;
		if (player_x_speed==5) return 1;
	}
	if (player_x_speed<0) {
		while (scan<16) {
			SetPlane(DARK_PLANE);
			if (GetPix(player_x-1,player_y+scan)) {
				player_x_speed=0;
				return 0;
			}
			SetPlane(LIGHT_PLANE);
			if (GetPix(player_x-1,player_y+scan)) {
				player_x_speed=0;
				return 0;
			}
			scan++;
		}
		player_x--;
		if ((!(_rowread(ARROWS_ROW) & LEFT_KEY)))	player_x_speed++;
		if (player_x_speed==-1) return 8;
		if (player_x_speed==-2) return 5;
		if (player_x_speed==-3) return 3;
		if (player_x_speed==-4) return 2;
		if (player_x_speed==-5) return 1;
	}
	return 0;
}


int update_player_y(void)
{
	int scan=0;
	if (player_y_speed>0) {  // UP..
		while (scan<8) {
			SetPlane(DARK_PLANE);
			if (GetPix(player_x+scan,player_y-1)) {
				player_y_speed=0;
				return 0;
			}
			SetPlane(LIGHT_PLANE);
			if (GetPix(player_x+scan,player_y-1)) {
				player_y_speed=0;
				return 0;
			}
			scan++;
		}
		player_y--;
		player_y_speed--;
		if (player_y_speed==1) return 4;
		if (player_y_speed==2) return 3;
		if (player_y_speed==3) return 2;
		if (player_y_speed==4) return 1;
		if (player_y_speed>=5) return 0;
	}
	if (player_y_speed<=0) {  // DOWN
		while (scan<8) {
			SetPlane(DARK_PLANE);
			if (GetPix(player_x+scan,player_y+16)) {
				player_y_speed=0;
				return 0;
			}
			SetPlane(LIGHT_PLANE);
			if (GetPix(player_x+scan,player_y+16)) {
				player_y_speed=0;
				return 0;
			}
			scan++;
		}
		player_y++;
		player_y_speed--;
		if (player_y_speed==-1) return 5;
		if (player_y_speed==-2) return 3;
		if (player_y_speed==-3) return 2;
		if (player_y_speed==-4) return 1;
		if (player_y_speed<=-5) return 0;
	}
	return 0;
}

int On_Ground(void) {
	int scan=0;
  SetPlane (DARK_PLANE);
	while (scan<8) {
		if (GetPix(player_x+scan,player_y+16)) return TRUE;
		scan++;
	}
	return FALSE;
}
